/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "fatfs.h"
#include "spi.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "SD_Card_APP.h"
#include "SSD1306.h"
#include "Fonts.h"
#include "Browser.h"
#include "logger.h"
#include "st_errno.h"
#include "rfal_rf.h"
#include "rfal_analogConfig.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
	extern char filename[20][20];
	extern uint8_t file_num;
	
int GetCompileDateTime(void)
{       
       const int  MONTH_PER_YEAR=12;
       const char szEnglishMonth[MONTH_PER_YEAR][4]={ "Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
       char szTmpDate[40]={0};
       char szTmpTime[20]={0};
       char szMonth[4]={0};
       int iYear,iMonth,iDay,iHour,iMin,iSec;//,,

       //ȡڡʱ
       sprintf(szTmpDate,"%s",__DATE__); //"Sep 18 2010"
       sprintf(szTmpTime,"%s",__TIME__);   //"10:59:19"
       
			 printf("%s \r\n",__DATE__);
			 printf("%s \r\n",__TIME__);
			 
			 printf("xx = %x %x %x \r\n",(__TIME__[0]-'0')*16+(__TIME__[1]-'0'),(__TIME__[3]-'0')*16+(__TIME__[4]-'0'),(__TIME__[6]-'0')*16+(__TIME__[7]-'0'));
       sscanf(szTmpDate,"%s %d %d",szMonth,&iDay,&iYear);
       sscanf(szTmpTime,"%d:%d:%d",&iHour,&iMin,&iSec);
               
       for(int i=0;MONTH_PER_YEAR;i++)
       {
               if(strncmp(szMonth,szEnglishMonth[i],3)==0)
               {
                       iMonth=i+1;
                       break;
               }
       }

       //printf("%d,%d,%d,%d,%d,%d\n",iYear,iMonth,iDay,iHour,iMin,iSec);
       //sprintf(szDateTime,"dddddd",iYear,iMonth,iDay,iHour,iMin,iSec);
			 printf ("iMonth = %d\r\n",(iMonth/10)*16+iMonth%10);
       return iMonth;
}
/* USER CODE END 0 */


/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
	
  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USART2_UART_Init();
  MX_FATFS_Init();
  MX_SPI2_Init();
  MX_SPI1_Init();
  MX_TIM3_Init();
  /* USER CODE BEGIN 2 */
	SpiInit(&hspi1);
	printf("Hello\r\n");
	/* Initalize RFAL */
  rfalAnalogConfigInitialize();	
	/* Initalize OLED */
	ssd1306_init();	
//	GetCompileDateTime();
	/* Initalize SD Card */
	while(1)
	{
		if(!SDCard_Init()){	
			LED_RED_1;
			ssd1306_display_string(26, 16,"SD Card Error!", 12, 1);
			ssd1306_display_string(0,28,"Please press any key to try again.", 12, 1);
			ssd1306_refresh_gram();
		}else {	
			LED_RED_0;
			break;
		}
		while(!ReadKey());
	}

	if( rfalInitialize() != ERR_NONE ) 
  {
    /*
    * in case the rfal initalization failed signal it by flashing all LED
    * and stoping all operations
    */
    printf("RFAL initialization failed..\r\n");
    while(1) 
    {
      DEV_Delay_ms(100);
    }
  } 
  else
  {
    printf("RFAL initialization succeeded..\r\n");
      DEV_Delay_ms(200);
    
  }
	/**************Save file name ,return file number**************/	
	file_num = Browser_save_fileame("0:");		
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
    while (1) {
		/* Run RFAL Worker */
			rfalWorker();
		/* OLED Display*/
			Browser_display();
    /* USER CODE END WHILE */
	
    /* USER CODE BEGIN 3 */

    }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
    /* User can add his own implementation to report the HAL error return state */
    while(1) {
    }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
